# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv

class ricette_ricettario(osv.osv):
	_name = "ricette.ricettario"
	_description = "Ricettario"
	_columns = {
				'name': fields.char('Titolo', size=80, translate=True, required=True),
				'prefazione': fields.text('Breve descrizione', translate=True),
				'anno': fields.char('Anno edizione', size=4),
				'autore_id': fields.many2one('res.partner','Autore', ondelete='set null',required=True),
				'editore_id':fields.many2one('res.partner','Editore', ondelete='set null', required=True),
				'immagine': fields.binary('Copertina'),
				}
ricette_ricettario()

class ricette_ricetta(osv.osv):
	_name = "ricette.ricetta"
	_description = "Ricetta"
	_columns = {
				'titolo': fields.char('Titolo', size=80, translate=True, required=True),
				'descrizione': fields.char('Breve descrizione', size=150, translate=True, required=True),
				'tipo': fields.selection([('antipasto', 'antipasto'), ('primo', 'primo piatto'), ('secondo', 					'secondo piatto'), ('contorno', 'contorno'), ('dolce', 'dolce')], 'Tipo di piatto'),
				'difficolta': fields.selection([(1, 'facile'), (2, 'media'), (3, 'difficile'), (4, 'molto difficile')], 'Difficoltà'),
				'min_preparazione': fields.integer('Tempo di preparazione (min)'),
				'ingredienti': fields.text("Lista ingredienti", ),
				'preparazione': fields.text('Descrizione', required=True),     # required=obbligatorio
				'immagine': fields.binary('Immagine'),
				'ricettario_id': fields.many2one('ricette.ricettario','Ricettario', ondelete='set null'),				
				}

ricette_ricetta()

class ricette_ricettario(osv.osv):
	_name = "ricette.ricettario"
	_inherit = "ricette.ricettario"

	_columns = {
		       'ricette_ids': fields.one2many('ricette.ricetta', 'ricettario_id','Ricette'),
			   }
ricette_ricettario()

class res_partner(osv.osv):
	_name = "res.partner"
	_inherit = "res.partner"	#con l'inherit, creo un nuovo oggetto che deriva da un oggetto                        						#già esistente (padre) in modo da aggiungere dei campi.

	_columns = {
				'autori_ids': fields.one2many('ricette.ricettario', 'autore_id','Autore'),
				'editore_ids': fields.one2many('ricette.ricettario', 'editore_id', 'Editore'),
			   }
res_partner()

